from MSQRlib import *   #魔方陣用共通関数
def Hindu(N):#■ヒンズーの連続方式
    A=array(N,N); ii=0;jj=int(N/2)
    A[ii][jj]=1
    for k in range(2, N*N+1):
        i0=ii;j0=jj;ii=cID(N,ii-1);jj=cID(N,jj+1)
        if A[ii][jj]!=0: ii=cID(N,i0+1);jj=j0
        A[ii][jj]=k
    return A
def Bashe(N):#■バシェー方式
    A=array(N,N); k=0;N2=int(N/2)
    for i in range(-N2,N2+1):
        for j in range(0,N):
            k+=1; 
            A[cID(N,j+i)][cID(N,j-i)]=k
    return A
def keima(N):#■桂馬飛び法
    A=array(N,N);ii=0;jj=0;jj=int(N/2)
    #ii=int(N/2);jj=int(N/2)
    A[ii][jj]=1
    for k in range(2, N*N+1):
        i0=ii;j0=jj;ii=cID(N,i0+2);jj=cID(N,j0+1)
        if A[ii][jj]!=0: ii=cID(N,i0+1);jj=cID(N,j0-1)
        if A[ii][jj]!=0: ii=cID(N,i0+1);jj=cID(N,j0)
        if A[ii][jj]!=0: print("失敗"); return A
        A[ii][jj]=k
    return A
N=15
print("\n■ヒンズーの連続方式による%d×%d"%(N,N))
A=Hindu(N);printSQR(A)
print("\n■バシェー方式による%d×%d"%(N,N))
A=Bashe(N);printSQR(A)
print("\n■桂馬飛び法による%d×%d"%(N,N))
A=keima(N);printSQR(A)
checkComplete(A)
            
            
